/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.24 Revision 1.68
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.24 2009/08/07 01:00:11 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.68 2012/09/04 14:08:24 johu Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
16
15inherit kde4-base versionator 17inherit kde4-base versionator
16 18
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 19KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
18 20EXPORT_FUNCTIONS ${KDEMETA_EXPF}
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23# Add khelpcenter dependency when installing handbooks
24if [[ ${PN} != khelpcenter ]] && has handbook ${IUSE//+}; then
25 RDEPEND+=" handbook? ( >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=] )"
26fi
27 21
28# Add dependencies that all packages in a certain module share. 22# Add dependencies that all packages in a certain module share.
29case ${KMNAME} in 23case ${KMNAME} in
30 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics) 24 kdebase|kdebase-apps|kde-baseapps|kdebase-workspace|kde-workspace|kdebase-runtime|kde-runtime|kdegraphics)
31 COMMONDEPEND+=" >=kde-base/qimageblitz-0.0.4" 25 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
32 ;;
33 kdenetwork)
34 COMMONDEPEND+=" >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]"
35 ;; 26 ;;
36 kdepim|kdepim-runtime) 27 kdepim|kdepim-runtime)
37 COMMONDEPEND+="
38 dev-libs/boost
39 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
40 "
41 case ${PN} in 28 case ${PN} in
42 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
43 IUSE+=" +kontact" 30 IUSE+=" +kontact"
44 RDEPEND+=" kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )" 31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
45 ;; 32 ;;
46 esac 33 esac
47 ;; 34 ;;
48 kdegames) 35 kdegames)
49 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
50 COMMONDEPEND+=" >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=] " 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
51 fi
52 ;;
53 koffice)
54 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
55 RDEPEND+="
56 !app-office/${PN}:0
57 !app-office/koffice:0
58 !app-office/koffice-meta:0
59 "
60 if has openexr ${IUSE//+}; then
61 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
62 else
63 COMMONDEPEND+=" media-gfx/imagemagick"
64 fi
65
66 COMMONDEPEND+="
67 dev-cpp/eigen:2
68 media-libs/fontconfig
69 media-libs/freetype:2
70 "
71 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
72 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
73 fi 38 fi
74 ;; 39 ;;
75esac 40esac
76 41
77DEPEND+=" ${COMMONDEPEND}" 42DEPEND+=" ${COMMONDEPEND}"
80 45
81debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 46debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
82debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 47debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
83 48
84# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 49# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
85case ${BUILD_TYPE} in 50case ${KDE_BUILD_TYPE} in
86 live) 51 live)
52 if [[ ${KDE_SCM} == svn ]]; then
87 case ${KMNAME} in 53 case ${KMNAME} in
88 extragear*|playground*) 54 extragear*|playground*)
89 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 55 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
90 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}" 56 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
91 ;; 57 ;;
92 esac 58 esac
59 fi
93 ;; 60 ;;
94esac 61esac
95 62
96# @ECLASS-VARIABLE: KMNAME 63# @ECLASS-VARIABLE: KMNAME
97# @DESCRIPTION: 64# @DESCRIPTION:
112# If set to "true", $KMMODULE doesn't have to be defined. 79# If set to "true", $KMMODULE doesn't have to be defined.
113# 80#
114# Example usage: If you're installing subdirectories of a package, like plugins, 81# Example usage: If you're installing subdirectories of a package, like plugins,
115# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 82# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
116# set KMNOMODULE="true". 83# set KMNOMODULE="true".
117if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 84if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
118 KMMODULE=${PN} 85 KMMODULE=${PN}
119fi 86fi
120 87
121# @ECLASS-VARIABLE: KMEXTRA 88# @ECLASS-VARIABLE: KMEXTRA
122# @DESCRIPTION: 89# @DESCRIPTION:
123# All subdirectories listed here will be extracted, compiled & installed. 90# All subdirectories listed here will be extracted, compiled & installed.
124# $KMMODULE is always added to $KMEXTRA. 91# $KMMODULE is always added to $KMEXTRA.
125# If the handbook USE-flag is set, and if this directory exists, 92# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
126# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 93# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
127# handled in the ebuild.
128# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 94# documentation in different subdirectories, it should be added to KMEXTRA manually..
129 95
130# @ECLASS-VARIABLE: KMCOMPILEONLY 96# @ECLASS-VARIABLE: KMCOMPILEONLY
131# @DESCRIPTION: 97# @DESCRIPTION:
132# All subdirectories listed here will be extracted & compiled, but not installed. 98# All subdirectories listed here will be extracted & compiled, but not installed.
133 99
142# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 108# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
143# '-xpf -j' are passed to tar by default. 109# '-xpf -j' are passed to tar by default.
144 110
145# @FUNCTION: kde4-meta_pkg_setup 111# @FUNCTION: kde4-meta_pkg_setup
146# @DESCRIPTION: 112# @DESCRIPTION:
147# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 113# Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
148# split ebuilds. 114# Use this one in split ebuilds.
149kde4-meta_pkg_setup() { 115kde4-meta_pkg_setup() {
150 debug-print-function ${FUNCNAME} "$@" 116 debug-print-function ${FUNCNAME} "$@"
151 117
152 kde4-base_pkg_setup 118 kde4-base_pkg_setup
153} 119}
154 120
155# @FUNCTION: kde4-meta_src_unpack 121# @FUNCTION: kde4-meta_src_unpack
156# @DESCRIPTION: 122# @DESCRIPTION:
157# This function unpacks the source for split ebuilds. See also 123# This function unpacks the source for split ebuilds.
158# kde4-meta-src_extract. 124# Further more is processed in kde4-meta_src_extract
159kde4-meta_src_unpack() { 125kde4-meta_src_unpack() {
160 debug-print-function ${FUNCNAME} "$@" 126 debug-print-function ${FUNCNAME} "$@"
161 127
162 if [[ ${BUILD_TYPE} = live ]]; then 128 if [[ ${KDE_BUILD_TYPE} = live ]]; then
129 case "${KDE_SCM}" in
130 svn)
163 migrate_store_dir 131 migrate_store_dir
164 S="${WORKDIR}/${P}" 132 S="${WORKDIR}/${P}"
165 mkdir -p "${S}" 133 mkdir -p "${S}"
166 ESVN_RESTRICT="export" subversion_src_unpack 134 ESVN_RESTRICT="export" subversion_src_unpack
167 subversion_wc_info 135 subversion_wc_info
168 subversion_bootstrap 136 subversion_bootstrap
137 ;;
138 git)
139 git-2_src_unpack
140 ;;
141 esac
142 fi
169 kde4-meta_src_extract 143 kde4-meta_src_extract
170 else
171 kde4-meta_src_extract
172 fi
173} 144}
174
175# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
176 145
177# @FUNCTION: kde4-meta_src_extract 146# @FUNCTION: kde4-meta_src_extract
178# @DESCRIPTION: 147# @DESCRIPTION:
179# A function to unpack the source for a split KDE ebuild. 148# A function to extract the source for a split KDE ebuild.
180# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 149# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
181# KMTARPARAMS. 150# KMTARPARAMS.
182kde4-meta_src_extract() { 151kde4-meta_src_extract() {
183 debug-print-function ${FUNCNAME} "$@" 152 debug-print-function ${FUNCNAME} "$@"
184 153
185 if [[ ${BUILD_TYPE} = live ]]; then 154 if [[ ${KDE_BUILD_TYPE} = live ]]; then
186 local rsync_options subdir kmnamedir targetdir
187 # Export working copy to ${S} 155 # Export working copy to ${S}
188 einfo "Exporting parts of working copy to ${S}" 156 einfo "Exporting parts of working copy to ${S}"
189 kde4-meta_create_extractlists 157 kde4-meta_create_extractlists
190 158
159 case ${KDE_SCM} in
160 svn)
161 local rsync_options subdir targetdir wc_path escm
162
191 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/" 163 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
164 wc_path="${ESVN_WC_PATH}"
165 escm="{ESVN}"
192 166
193 # Copy ${KMNAME} non-recursively (toplevel files) 167 # Copy ${KMNAME} non-recursively (toplevel files)
194 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \ 168 rsync ${rsync_options} "${wc_path}"/* "${S}" \
195 || die "${ESVN}: can't export toplevel files to '${S}'." 169 || die "${escm}: can't export toplevel files to '${S}'."
196 # Copy cmake directory 170 # Copy cmake directory
197 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then 171 if [[ -d "${wc_path}/cmake" ]]; then
198 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 172 rsync --recursive ${rsync_options} "${wc_path}/cmake" "${S}" \
199 || die "${ESVN}: can't export cmake files to '${S}'." 173 || die "${escm}: can't export cmake files to '${S}'."
200 fi 174 fi
201 # Copy all subdirectories 175 # Copy all subdirectories
202 for subdir in $(__list_needed_subdirectories); do 176 for subdir in $(__list_needed_subdirectories); do
203 targetdir="" 177 targetdir=""
204 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then 178 if [[ $subdir = doc/* && ! -e "$wc_path/$subdir" ]]; then
205 continue 179 continue
206 fi 180 fi
207 181
208 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 182 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
209 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 183 rsync --recursive ${rsync_options} "${wc_path}/${subdir%/}" "${S}/${targetdir}" \
210 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 184 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
211 done 185 done
212
213 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
214 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
215 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
216 fi
217 else
218 local abort tarball tarfile f extractlist moduleprefix postfix
219 case ${PV} in
220 4.3.85 | 4.3.90 | 4.3.95 | 4.3.96 | 4.3.98 | 4.2.85 | 4.2.90 | 4.2.95 | 4.2.96 | 4.2.98)
221 # block for normally packed upstream unstable snapshots
222 KMTARPARAMS+=" --bzip2" # bz2
223 postfix="bz2"
224 ;;
225 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6* | 4.3.9* | 4.3.8* | 4.3.7* | 4.3.6*)
226 KMTARPARAMS+=" --lzma" # lzma
227 postfix="lzma"
228 ;;
229 *)
230 KMTARPARAMS+=" --bzip2" # bz2
231 postfix="bz2"
232 ;; 186 ;;
233 esac 187 esac
188 else
189 local abort tarball tarfile f extractlist postfix
190
191 if [[ ${PV} =~ 4.[47].[12345] ]]; then
192 postfix="bz2"
193 KMTARPARAMS+=" --bzip2"
194 else
195 postfix="xz"
196 KMTARPARAMS+=" --xz"
197 fi
198
234 case ${KMNAME} in 199 case ${KMNAME} in
235 kdebase-apps) 200 kdebase-apps)
236 # kdebase/apps -> kdebase-apps 201 # kdebase/apps -> kdebase-apps
237 tarball="kdebase-${PV}.tar.${postfix}" 202 tarball="kdebase-${PV}.tar.${postfix}"
238 # Go one level deeper for kdebase-apps in tarballs
239 moduleprefix=apps/
240 KMTARPARAMS+=" --transform=s|apps/||"
241 ;; 203 ;;
242 *) 204 *)
243 # Create tarball name from module name (this is the default) 205 # Create tarball name from module name (this is the default)
244 tarball="${KMNAME}-${PV}.tar.${postfix}" 206 tarball="${KMNAME}-${PV}.tar.${postfix}"
245 ;; 207 ;;
254 216
255 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 217 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
256 218
257 kde4-meta_create_extractlists 219 kde4-meta_create_extractlists
258 220
259 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 221 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake
260 AUTHORS COPYING INSTALL README NEWS ChangeLog
261 do 222 do
262 extractlist+=" ${topdir}${moduleprefix}${f}" 223 extractlist+=" ${topdir}${f}"
263 done 224 done
264 extractlist+=" $(__list_needed_subdirectories)" 225 extractlist+=" $(__list_needed_subdirectories)"
265 226
266 pushd "${WORKDIR}" > /dev/null 227 pushd "${WORKDIR}" > /dev/null
228
229 # @ECLASS-VARIABLE: KDE4_STRICTER
230 # @DESCRIPTION:
231 # Print out all issues found executing tar / kmextract files
232 # Set on if you want to find issues in kde-base ebuild unpack sequences
267 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 233 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
268 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 234 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
269 235
270 # Default $S is based on $P; rename the extracted directory to match $S if necessary 236 # Default $S is based on $P; rename the extracted directory to match $S if necessary
237 if [[ ${KMNAME} != ${PN} ]]; then
271 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\"" 238 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
239 fi
272 240
273 popd > /dev/null 241 popd > /dev/null
274 242
275 eend $? 243 eend $?
276
277 # We need to clear it here to make verification below work
278 unset moduleprefix
279 244
280 if [[ -n ${KDE4_STRICTER} ]]; then 245 if [[ -n ${KDE4_STRICTER} ]]; then
281 for f in $(__list_needed_subdirectories fatal); do 246 for f in $(__list_needed_subdirectories fatal); do
282 if [[ ! -e "${S}/${f#*/}" ]]; then 247 if [[ ! -e ${S}/${f#*/} ]]; then
283 eerror "'${f#*/}' is missing" 248 eerror "'${f#*/}' is missing"
284 abort=true 249 abort=true
285 fi 250 fi
286 done 251 done
287 [[ -n ${abort} ]] && die "There were missing files." 252 [[ -n ${abort} ]] && die "There were missing files."
298# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 263# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
299# KMEXTRACTONLY and KMTARPARAMS. 264# KMEXTRACTONLY and KMTARPARAMS.
300kde4-meta_create_extractlists() { 265kde4-meta_create_extractlists() {
301 debug-print-function ${FUNCNAME} "$@" 266 debug-print-function ${FUNCNAME} "$@"
302 267
303 # TODO change to KMEXTRA for more strict check 268 # Add default handbook locations
304 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then 269 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
270 if [[ $(get_kde_version) < 4.5 ]] && use_if_iuse handbook && [[ -z ${KMNOMODULE} ]]; then
305 # We use the basename of $KMMODULE because $KMMODULE can contain 271 # We use the basename of $KMMODULE because $KMMODULE can contain
306 # the path to the module subdirectory. 272 # the path to the module subdirectory.
307 KMEXTRA_NONFATAL+=" 273 KMEXTRA_NONFATAL+="
308 doc/${KMMODULE##*/}" 274 doc/${KMMODULE##*/}"
309 fi 275 fi
310 276
277 # Add default handbook locations
278 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
279 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
280 fi
281
311 # Add some CMake-files to KMEXTRACTONLY. 282 # Add some CMake-files to KMEXTRACTONLY.
312 # Note that this actually doesn't include KMEXTRA handling. 283 # Note that this actually doesn't include KMEXTRA handling.
313 # In those cases you should care to add the relevant files to KMEXTRACTONLY 284 # In those cases you should care to add the relevant files to KMEXTRACTONLY
314 case ${KMNAME} in 285 case ${KMNAME} in
315 kdebase) 286 kdebase | kdebase-apps | kde-baseapps)
316 KMEXTRACTONLY+="
317 apps/config-apps.h.cmake
318 apps/ConfigureChecks.cmake"
319 ;;
320 kdebase-apps)
321 KMEXTRACTONLY+=" 287 KMEXTRACTONLY+="
322 config-apps.h.cmake 288 config-apps.h.cmake
323 ConfigureChecks.cmake" 289 ConfigureChecks.cmake"
324 ;; 290 ;;
325 kdebase-runtime) 291 kdebase-runtime | kde-runtime)
326 KMEXTRACTONLY+=" 292 KMEXTRACTONLY+="
293 CTestConfig.cmake
327 config-runtime.h.cmake" 294 config-runtime.h.cmake"
328 ;; 295 ;;
329 kdebase-workspace) 296 kdebase-workspace | kde-workspace)
330 KMEXTRACTONLY+=" 297 KMEXTRACTONLY+="
331 config-unix.h.cmake 298 config-unix.h.cmake
332 ConfigureChecks.cmake 299 ConfigureChecks.cmake
333 config-workspace.h.cmake 300 config-workspace.h.cmake
334 config-X11.h.cmake 301 config-X11.h.cmake
337 ;; 304 ;;
338 kdegames) 305 kdegames)
339 if [[ ${PN} != libkdegames ]]; then 306 if [[ ${PN} != libkdegames ]]; then
340 KMEXTRACTONLY+=" 307 KMEXTRACTONLY+="
341 libkdegames/" 308 libkdegames/"
309 KMLOADLIBS="${KMLOADLIBS} libkdegames"
342 fi 310 fi
343 ;; 311 ;;
344 kdepim) 312 kdepim)
345 if [[ ${PN} != libkdepim ]]; then 313 if [[ ${PN} != libkdepim ]]; then
346 KMEXTRACTONLY+=" 314 KMEXTRACTONLY+="
347 libkdepim/" 315 libkdepim/"
348 fi 316 fi
349 case ${SLOT} in
350 4.3|4.4|live)
351 KMEXTRACTONLY+="
352 kdepim-version.h
353 config-enterprise.h.cmake"
354 ;;
355 esac
356 KMEXTRACTONLY+=" 317 KMEXTRACTONLY+="
318 config-enterprise.h.cmake
357 kleopatra/ConfigureChecks.cmake" 319 kleopatra/ConfigureChecks.cmake"
358 if has kontact ${IUSE//+} && use kontact; then 320 if ! [[ $(get_kde_version) < 4.5 ]]; then
321 KMEXTRACTONLY+="
322 CTestCustom.cmake
323 kdepim-version.h.cmake"
324 else
325 KMEXTRACTONLY+="
326 kdepim-version.h"
327 fi
328 if use_if_iuse kontact; then
359 KMEXTRA+=" 329 KMEXTRA+="
360 kontact/plugins/${PLUGINNAME:-${PN}}/" 330 kontact/plugins/${PLUGINNAME:-${PN}}/"
361 KMEXTRACTONLY+="
362 kontactinterfaces/"
363 fi 331 fi
364 ;; 332 ;;
365 kdeutils) 333 kdeutils)
366 case ${SLOT} in
367 4.3|4.4|live)
368 KMEXTRACTONLY+="
369 kdeutils-version.h"
370 ;;
371 esac
372 ;;
373 koffice)
374 KMEXTRACTONLY+=" 334 KMEXTRACTONLY+="
375 config-endian.h.cmake 335 kdeutils-version.h"
376 filters/config-filters.h.cmake
377 config-openexr.h.cmake
378 config-opengl.h.cmake
379 config-prefix.h.cmake
380 "
381 case ${PV} in
382 2.0.*)
383 KMEXTRACTONLY+="
384 config-openctl.h.cmake"
385 ;;
386 esac
387 ;; 336 ;;
388 esac 337 esac
389 # Don't install cmake modules for split ebuilds, to avoid collisions. 338 # Don't install cmake modules for split ebuilds, to avoid collisions.
339 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
340 # should not try in that case
341 # note2: kdeedu 4.6.4 does not have a cmake/modules/ subdir anymore :(
342 # it may be possible to formulate this shorter, but it should also
343 # still be understandable...
344 if [[ ${KMNAME} != kdegraphics || ( ( $(get_kde_version) != 4.6 || ${PV} < 4.6.2 ) && $(get_kde_version) < 4.7 ) ]] \
345 && ! [[ ${KMNAME} == kdeedu && ( ${PV} == 4.6.4 || ${PV} == 4.6.5 ) ]] \
346 && ! [[ ${KMNAME} == kdegames && ${PV} > 4.9.0 ]]; then
390 case ${KMNAME} in 347 case ${KMNAME} in
391 kdepim) 348 kdebase-runtime|kde-runtime|kdebase-workspace|kde-workspace|kdeedu|kdegames|kdegraphics)
392 # No need for unpack since 4.2.86 349 KMEXTRACTONLY+="
393 # Remove when 4.2 is wiped out from the tree
394 case ${PV} in
395 4.1*|4.2.0|4.2.1|4.2.2|4.2.3|4.2.4|4.2.85)
396 KMCOMPILEONLY+="
397 cmake/modules/" 350 cmake/modules/"
398 ;; 351 ;;
399 *) ;;
400 esac 352 esac
401 ;; 353 fi
402 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
403 case ${PN} in
404 libkdegames|libkdeedu|libkworkspace)
405 KMEXTRA+="
406 cmake/modules/"
407 ;;
408 *)
409 KMCOMPILEONLY+="
410 cmake/modules/"
411 ;;
412 esac
413 ;;
414 esac
415 354
416 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 355 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
417} 356}
418 357
419__list_needed_subdirectories() { 358__list_needed_subdirectories() {
458 # Create final list of stuff to extract 397 # Create final list of stuff to extract
459 # We append topdir only when specified (usually for tarballs) 398 # We append topdir only when specified (usually for tarballs)
460 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 399 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
461 ${KMEXTRACTONLY} 400 ${KMEXTRACTONLY}
462 do 401 do
463 extractlist+=" ${topdir}${moduleprefix}${i}" 402 extractlist+=" ${topdir}${i}"
464 done 403 done
465 404
466 echo ${extractlist} 405 echo ${extractlist}
467} 406}
468 407
474 413
475 kde4-meta_change_cmakelists 414 kde4-meta_change_cmakelists
476 kde4-base_src_prepare 415 kde4-base_src_prepare
477} 416}
478 417
479# FIXME: no comment here? 418# @FUNCTION: _change_cmakelists_parent_dirs
419# @DESCRIPTION:
420# Adjust CMakeLists.txt to shadow subdirectories
421# that are not required for the build.
480_change_cmakelists_parent_dirs() { 422_change_cmakelists_parent_dirs() {
481 debug-print-function ${FUNCNAME} "$@" 423 debug-print-function ${FUNCNAME} "$@"
482 424
483 local _olddir _dir 425 local _olddir _dir
484 _dir="${S}"/${1} 426 _dir="${S}"/${1}
485 until [[ ${_dir} == "${S}" ]]; do 427 until [[ ${_dir} == ${S} ]]; do
486 _olddir=$(basename "${_dir}") 428 _olddir=$(basename "${_dir}")
487 _dir=$(dirname "${_dir}") 429 _dir=$(dirname "${_dir}")
488 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 430 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
489 if [[ -f ${_dir}/CMakeLists.txt ]]; then 431 if [[ -f ${_dir}/CMakeLists.txt ]]; then
490 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \ 432 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
492 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 434 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
493 fi 435 fi
494 done 436 done
495} 437}
496 438
497# FIXME: add description
498# @FUNCTION: kde4-meta_change_cmakelists 439# @FUNCTION: kde4-meta_change_cmakelists
499# @DESCRIPTION: 440# @DESCRIPTION:
441# Adjust CMakeLists.txt to comply to our splitting.
500kde4-meta_change_cmakelists() { 442kde4-meta_change_cmakelists() {
501 debug-print-function ${FUNCNAME} "$@" 443 debug-print-function ${FUNCNAME} "$@"
502 444
503 pushd "${S}" > /dev/null 445 pushd "${S}" > /dev/null
504 446
505 comment_all_add_subdirectory ./ 447 comment_all_add_subdirectory ./
506 448
507 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 449 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
508 if [[ -f "${S}"/CMakeLists.txt ]]; then 450 if [[ -f CMakeLists.txt ]]; then
509 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 451 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
510 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 452 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
511 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 453 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
454 fi
455
456 # Restore "add_subdirectory( ${ ..." (this is done in kdesdk)
457 if [[ -f CMakeLists.txt ]]; then
458 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
459 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
460 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
512 fi 461 fi
513 462
514 if [[ -z ${KMNOMODULE} ]]; then 463 if [[ -z ${KMNOMODULE} ]]; then
515 # Restore "add_subdirectory" in $KMMODULE subdirectories 464 # Restore "add_subdirectory" in $KMMODULE subdirectories
516 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 465 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
466 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
517 die "${LINENO}: died in KMMODULE section" 467 die "${LINENO}: died in KMMODULE section"
518 _change_cmakelists_parent_dirs ${KMMODULE} 468 _change_cmakelists_parent_dirs ${KMMODULE}
519 fi 469 fi
520 470
521 local i 471 local i
522 472
523 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 473 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
524 for i in ${KMEXTRACTONLY}; do 474 for i in ${KMEXTRACTONLY}; do
525 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 475 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
526 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 476 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
477 -i ${i}/../CMakeLists.txt || \
527 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 478 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
528 fi 479 fi
529 done 480 done
530 481
531 # KMCOMPILEONLY 482 # KMCOMPILEONLY
553 # KMEXTRA_NONFATAL section 504 # KMEXTRA_NONFATAL section
554 for i in ${KMEXTRA_NONFATAL}; do 505 for i in ${KMEXTRA_NONFATAL}; do
555 if [[ -d "${S}"/${i} ]]; then 506 if [[ -d "${S}"/${i} ]]; then
556 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 507 find "${S}"/${i} -name CMakeLists.txt -print0 | \
557 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 508 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
558 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 509 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
559 _change_cmakelists_parent_dirs ${i} 510 _change_cmakelists_parent_dirs ${i}
560 fi 511 fi
561 done 512 done
562 513
563 case ${KMNAME} in 514 case ${KMNAME} in
564 kdebase-workspace) 515 kdebase-workspace | kde-workspace)
565 # COLLISION PROTECT section 516 # COLLISION PROTECT section
566 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 517 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
567 # not as a part of every package. 518 # not as a part of every package.
568 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 519 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
569 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 520 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
570 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 521 sed -e '/startkde/s/^/#DONOTINSTALL /' \
571 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 522 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
572 fi 523 fi
524 # Remove workspace target prefix in order to get direct linking to workspace libs
525 sed -e '/set(KDE4WORKSPACE_TARGET_PREFIX/s/^/#OVERRIDE /' \
526 -i CMakeLists.txt || die "${LINENO}: sed died in KDE4WORKSPACE_TARGET_PREFIX removal section"
573 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 527 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
574 if [[ ${PN} != libkworkspace ]]; then 528 if [[ ${PN} != libkworkspace ]]; then
575 sed -i \
576 -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 529 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
577 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section" 530 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace strip config install and fix EXPORT section"
578 fi 531 fi
532 if [[ ${PN} != plasma-workspace ]]; then
533 sed -e '/KActivities/s/REQUIRED//' \
534 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace dep reduction section"
535 fi
536 if [[ "${PN}" != "kwin" ]]; then
537 sed -i -e "/^ macro_log_feature(OPENGL_OR_ES_FOUND/s/TRUE/FALSE/" \
538 "${S}"/CMakeLists.txt || die "${LINENO}: sed died removing kde-workspace opengl dependency"
539 fi
579 ;; 540 ;;
580 kdebase-runtime) 541 kdebase-runtime | kde-runtime)
581 # COLLISION PROTECT section 542 # COLLISION PROTECT section
582 # Only install the kde4 script as part of kde-base/kdebase-data 543 # Only install the kde4 script as part of kde-base/kdebase-data
583 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 544 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
584 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 545 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
585 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 546 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
586 fi 547 fi
548 ;;
549 kdenetwork)
550 # Disable hardcoded kdepimlibs check
551 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
552 -i CMakeLists.txt || die "failed to disable hardcoded checks"
587 ;; 553 ;;
588 kdepim) 554 kdepim)
555 # Disable hardcoded checks
556 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
557 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
558 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
559 -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*/if(1) # &/' \
560 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
561 -i CMakeLists.txt || die "failed to disable hardcoded checks"
562 # Disable broken or redundant build logic
563 if use_if_iuse kontact || [[ ${PN} = kontact ]]; then
564 sed -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*$/if(1) # &/' \
565 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
566 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
567 fi
568 if [[ $(get_kde_version) < 4.5 ]]; then
589 case ${PN} in 569 case ${PN} in
590 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 570 kalarm|kmailcvt|kontact|korganizer|korn)
591 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 571 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
592 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 572 -e '/add_custom_target(kmail_xml /,/)/p' \
573 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
593 _change_cmakelists_parent_dirs kmail 574 _change_cmakelists_parent_dirs kmail
594 ;; 575 ;;
595 esac 576 esac
577 fi
596 ;; 578 ;;
597 kdewebdev) 579 kdewebdev)
598 # Disable hardcoded kdepimlibs check 580 # Disable hardcoded checks
599 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 581 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
600 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \ 582 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
601 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \ 583 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
602 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \ 584 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
603 -i CMakeLists.txt || die "failed to disable hardcoded checks" 585 -i CMakeLists.txt || die "failed to disable hardcoded checks"
604 ;; 586 ;;
605 koffice)
606 # prevent collisions
607 if [[ ${PN} != koffice-data ]]; then
608 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
609 "${S}"/cmake/modules/CMakeLists.txt || \
610 die "${LINENO}: sed died in collision prevention section"
611 case ${PV} in
612 2.0.*)
613 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
614 "${S}"/CMakeLists.txt || \
615 die "${LINENO}: sed died in collision prevention section"
616 ;;
617 *)
618 sed -i -e '/install(.\+config-openexr\.h.\+)/d' \
619 "${S}"//CMakeLists.txt || \
620 die "${LINENO}: sed died in collision prevention section"
621 ;;
622 esac
623 fi
624 esac 587 esac
625 588
626 popd > /dev/null 589 popd > /dev/null
627} 590}
628 591
631# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 594# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
632# ebuilds. 595# ebuilds.
633kde4-meta_src_configure() { 596kde4-meta_src_configure() {
634 debug-print-function ${FUNCNAME} "$@" 597 debug-print-function ${FUNCNAME} "$@"
635 598
599 # backwards-compatibility: make mycmakeargs an array, if it isn't already
600 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
601 mycmakeargs=(${mycmakeargs})
602 fi
603
636 # Set some cmake default values here (usually workarounds for automagic deps) 604 # Set some cmake default values here (usually workarounds for automagic deps)
637 case ${KMNAME} in 605 case ${KMNAME} in
638 kdewebdev) 606 kdewebdev)
639 mycmakeargs=" 607 mycmakeargs=(
640 -DWITH_KdepimLibs=OFF 608 -DWITH_KdepimLibs=OFF
641 -DWITH_LibXml2=OFF 609 -DWITH_LibXml2=OFF
642 -DWITH_LibXslt=OFF 610 -DWITH_LibXslt=OFF
643 -DWITH_Boost=OFF 611 -DWITH_Boost=OFF
644 -DWITH_LibTidy=OFF 612 -DWITH_LibTidy=OFF
645 ${mycmakeargs}" 613 "${mycmakeargs[@]}"
614 )
646 ;; 615 ;;
647 esac 616 esac
648 617
649 kde4-base_src_configure 618 kde4-base_src_configure
650} 619}
659 kde4-base_src_compile "$@" 628 kde4-base_src_compile "$@"
660} 629}
661 630
662# @FUNCTION: kde4-meta_src_test 631# @FUNCTION: kde4-meta_src_test
663# @DESCRIPTION: 632# @DESCRIPTION:
664# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 633# Currently just calls its equivalent in kde4-base.eclass(5) if
665# ebuilds. 634# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
666kde4-meta_src_test() { 635kde4-meta_src_test() {
667 debug-print-function $FUNCNAME "$@" 636 debug-print-function $FUNCNAME "$@"
668 637
638 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
669 kde4-base_src_test 639 kde4-base_src_test
640 else
641 einfo "Tests disabled"
642 fi
670} 643}
671 644
672# @FUNCTION: kde4-meta_src_install 645# @FUNCTION: kde4-meta_src_install
673# @DESCRIPTION: 646# @DESCRIPTION:
674# Function for installing KDE4 split applications. 647# Function for installing KDE4 split applications.
675kde4-meta_src_install() { 648kde4-meta_src_install() {
676 debug-print-function $FUNCNAME "$@" 649 debug-print-function $FUNCNAME "$@"
677 650
651 # Search ${S}/${KMMODULE} and install common documentation files found
652 local doc
653 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
654 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
655 done
656
678 kde4-base_src_install 657 kde4-base_src_install
679} 658}
680 659
681# @FUNCTION: kde4-meta_src_make_doc 660# @FUNCTION: kde4-meta_pkg_preinst
682# @DESCRIPTION: 661# @DESCRIPTION:
683# This function searches in ${S}/${KMMODULE}, 662# Invoke its equivalent in kde4-base.eclass.
684# and tries to install "AUTHORS ChangeLog* README* NEWS TODO" if these files exist. 663kde4-meta_pkg_preinst() {
685kde4-meta_src_make_doc() {
686 debug-print-function ${FUNCNAME} "$@" 664 debug-print-function ${FUNCNAME} "$@"
687 665
688 local doc 666 kde4-base_pkg_preinst
689 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
690 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
691 done
692
693 kde4-base_src_make_doc
694} 667}
695 668
696# @FUNCTION: kde4-meta_pkg_postinst 669# @FUNCTION: kde4-meta_pkg_postinst
697# @DESCRIPTION: 670# @DESCRIPTION:
698# Display information about application handbook and invoke kbuildsycoca4. 671# Invoke kbuildsycoca4.
699kde4-meta_pkg_postinst() { 672kde4-meta_pkg_postinst() {
700 debug-print-function ${FUNCNAME} "$@" 673 debug-print-function ${FUNCNAME} "$@"
701
702 if has handbook ${IUSE//+} && ! use handbook; then
703 echo
704 einfo "Application handbook for ${PN} has not been installed."
705 einfo "To install handbook, reemerge =${CATEGORY}/${PF} with 'handbook' USE flag."
706 echo
707 fi
708 674
709 kde4-base_pkg_postinst 675 kde4-base_pkg_postinst
710} 676}
711 677
712# @FUNCTION: kde4-meta_pkg_postrm 678# @FUNCTION: kde4-meta_pkg_postrm

Legend:
Removed from v.1.24  
changed lines
  Added in v.1.68

  ViewVC Help
Powered by ViewVC 1.1.20